layui.extend({
    common    :   'js/common',
    orgTree    :   'layui/lay/mymodules/org-tree',
    region    :   'layui/lay/mymodules/region',
    xmSelect    :   'layui/dist/xm-select',
}).use(['tree','table', 'jquery','layer','common','orgTree','region','form','xmSelect'], function () {
    //  弹窗插件
    var layer = layui.layer;
    //  Jquery插件
    var $ = layui.jquery;
    //  引入公共模块
    var common = layui.common;
    //  引入表格
    var table = layui.table;
    //  引入表单
    var form = layui.form;
    //  引入下拉菜单
    var xmSelect = layui.xmSelect;

    var layuiTable = null;

    // 查询框表单
    var $node = {
        //  小区名称
        nameInput  :  $('input[name="name"]'),
        //  小区编号
        residentialNumberInput  :  $('input[name="residentialNumber"]'),
        //  物业名称
        estatePid  :  $('#estate_pid'),
        //  分配状态
        isAssign : $('#isAssign'),
        //  省市区表单
        provinceInput   :   $('input[name="regionProvince"]'),

        cityInput       :   $('input[name="regionCity"]'),

        areaInput       :   $('input[name="regionArea"]'),

        regionInput     :   $('#region'),
    };

    //  页面数据
    var pageData = {
        myOrgId     :   parseInt($('#org_id').val())
    };

    //选中id集合
    var ids = [];
    //清空选中集合
    var clearCheckbox = function(){
        ids=[];
    }
    //tableId集合
    var table_data = [];

    //选中树的Id和类型
    var selectTreeId = null;
    var selectTreeType = null;
    //  重新加载表格
    var reloadTable = function(obj){
        //重新加载表格
        layuiTable.reload({
            where:{
                name  :  $node.nameInput.val(),
                residentialNumber  :  $node.residentialNumberInput.val(),
                estatePid : $node.estatePid.val(),
                regionProvince  :  $node.provinceInput.val(),
                regionCity  :  $node.cityInput.val(),
                regionArea  :  $node.areaInput.val(),
                isAssign  :  $node.isAssign.val(),
                selectTreeId  :  selectTreeId,
                //排序
                sortField   :   obj?obj.field:'',
                sortOrder   :   obj?obj.type:'',
            }
            //重新从第1页开始
            ,page: {
                curr: 1
            },
            initSort:obj
        });
    };

    //  初始化
    (function(){
        //  加载树形列表
       layui.orgTree({
            //  点击路径的回调函数
            pathClickFn     :   function(item){
                selectTreeId = item.id;
                selectTreeType = item.orgType;
                estateSelect.setValue([]);
                $node.estatePid.val('');
                reloadTable();
            },
            //  点击树的回调函数
            treeClickFn     :   function(item){
                selectTreeId = item.id;
                selectTreeType = item.orgType;
                estateSelect.setValue([]);
                $node.estatePid.val('');
                reloadTable();
            },
            //  当前用户的机构Id
            orgId   :   pageData.myOrgId,
            //  截至级别（不包含）
            isShowFlag : 2
        });
        //  初始化表格
        layuiTable = common.layuiTable.render(layui.table,{
            elem: '#table_id'
            ,url: '/estate/residential/showResidentialList?status=-2'
            ,cellMinWidth: 80 //全局定义常规单元格的最小宽度，
            , cols: [[
                { type: 'checkbox'}
                ,{ field: 'name', title: '小区名称', width:200, align: 'center'}
                , { field: 'residentialNumber', title: '小区编号', align: 'center'}
                , { field: 'orgPidName', title: '所属机构', align: 'center' }
                , { field: 'estatePidName', title: '所属物业', align: 'center' }
                , { field: 'region', title: '小区地址', align: 'center' }
                // , { field: 'totalUnitNumber', title: '单元总数' , align: 'center'}
                // , { field: 'totalRoomNumber', title: '房间总数', align: 'center' }
                // , { field: 'totalUserNumber', title: '住户总数' , align: 'center'}
                , { field: '',align: 'center', title: '入住率',templet: function (d) {
                       // if(!d.totalRoomNumber){---房间总数
                       if(!d.roomNumber){
                           return "0.00%";
                       }else{
                           //已入住房间除以房间总数
                           // return (d.existRoomCount/d.totalRoomNumber*100).toFixed(2)+"%";
                           //已入住房间除以已录入房间
                           return (d.existRoomCount/d.roomNumber*100).toFixed(2)+"%";
                       }
                    } }
                , { field: 'unitNumber', title: '已录单元总数', align: 'center' }
                , { field: 'roomNumber', title: '已录房间总数', align: 'center' }
                , { field: 'userNumber', title: '已录住户总数', align: 'center' }
                , { field: 'userFaceNumber', title: '已录住户人脸数', align: 'center' }
                , { field: 'createDate', title: '添加时间', align: 'center',sort:true }
                , { title: '操作',width:180,align: 'center', toolbar: '#table-useradmin-webuser' }
            ]]
            //  开启分页功能
            , page: true
            ,done:function(res,curr,count){
                // 设置换页勾选之前的
                table_data = res.data;
                for(var i=0;i<res.data.length;i++){
                    for(var j=0;j<ids.length;j++){
                        if(res.data[i].id==ids[j]){
                            //这里才是真正的有效勾选
                            res.data[i]["LAY_CHECKED"]='true';
                            //找到对应数据改变勾选样式，呈现出选中效果
                            var index= res.data[i]['LAY_TABLE_INDEX'];
                            $('.layui-table tr[data-index=' + index + '] input[type="checkbox"]').prop('checked', true);
                            $('.layui-table tr[data-index=' + index + '] input[type="checkbox"]').next().addClass('layui-form-checked');
                        }
                    }
                }
                //设置全选checkbox的选中状态，只有改变LAY_CHECKED的值， table.checkStatus才能抓取到选中的状态
                var checkStatus = table.checkStatus('table_id');
                if(checkStatus.isAll){
                    $(' .layui-table-header th[data-field="0"] input[type="checkbox"]').prop('checked', true);
                    $('.layui-table-header th[data-field="0"] input[type="checkbox"]').next().addClass('layui-form-checked');
                }
            }
        });
    })();

    //排序
    layui.table.on('sort(table_event)',function (obj) {
        reloadTable(obj);
    });

    //复选框选中监听,将选中的id 设置到缓存数组,或者删除缓存数组
    table.on('checkbox(table_event)', function (obj) {
        if(obj.checked==true){
            if(obj.type=='one'){
                ids.push(obj.data.id)
            }else{
                for(var i=0;i<table_data.length;i++){
                    ids.push(table_data[i].id);
                }
            }
        }else{
            if(obj.type=='one'){
                for(var i=0;i<ids.length;i++){
                    if(ids[i]==obj.data.id){
                        ids.splice(i,1);
                        return;
                    }
                }
            }else{
                for(var i=0;i<ids.length;i++){
                    for(var j=0;j<table_data.length;j++){
                        if(ids[i]==table_data[j].id){
                            ids.splice(i,1);
                            i--;
                            break;
                        }
                    }
                }
            }
        }
    });

    //  初始化省市区
    layui.region.init({
        //  元素节点
        elem        :  '#region_body',
        //  触发此元素时显示
        trigger     :   '#region',
        //  选中省的回调
        provinceCallbackFn  :   function(data){
            var address = data.province.text;
            $node.regionInput.val(address);
            $node.provinceInput.val(data.province.id);
        },
        //  选中市的回调
        cityCallbackFn  :   function(data){
            var address = data.province.text + '-' + data.city.text;
            $node.regionInput.val(address);
            $node.cityInput.val(data.city.id);
        },
        //  选中区域的回调
        areaCallbackFn  :   function(data){
            var address = data.province.text + '-' + data.city.text + '-' +data.county.text;
            $node.regionInput.val(address);
            $node.areaInput.val(data.county.id);
        },
        //  关闭时的回调
        hideCallbackFn  :   function(data){
        },
        //清空回调
        clearFn : function(){
            $node.regionInput.val('');
            $node.provinceInput.val('');
            $node.cityInput.val('');
            $node.areaInput.val('');
        }
    });

    //监听行工具事件 lay-filter="table_event"
    table.on('tool(table_event)', function(obj){
        var data = obj.data; //获得当前行数据
        switch (obj.event) {
            case 'del'://删除
                layer.confirm('是否确认删除？',{icon: 7, title:'提示'}, function(index){
                    common.sendAsyncRequest("/estate/residential/deleteResidential",'POST',{
                        id  :  data.id
                    },function (result){
                        if(result.data){
                            //  刷新表格
                            layuiTable.reload();
                            layer.msg("删除成功");
                            layer.close(index);
                        }else{
                            layer.msg("删除失败");
                        }
                    });
                });
                break;
            case 'recover' :
                layer.confirm('是否确认恢复？',{icon: 7, title:'提示'}, function(index){
                    var loadIndex = layer.load(1);
                    common.sendAsyncRequest("/estate/residential/trashOrRecover",'POST',{
                        id      :   data.id,
                        order   :   0,
                    },function (result){
                        layer.close(loadIndex);
                        if(result.data){
                            //  刷新表格
                            layer.close(index);
                            layuiTable.reload();
                            layer.msg("恢复成功");
                        }else{
                            layer.msg("恢复失败");
                        }
                    });
                });
                break;
            default:
                break;
        };
    });

    var resetAreaFn = function () {
        $('.select-type li').removeClass('active');
        $('.select-type li').eq(0).addClass('active');
        $('.zm-ctn li').removeClass('active');
        $('.select-type-ctn .type-main').hide();
        $('.select-type-ctn .province').show();
        $('.select-type-ctn .city .zm-ctn').empty();
        $('.select-type-ctn .city .zm').show();
        $('.select-type-ctn .county .zm-ctn').empty();
        $('.select-type-ctn .county .zm').show();
    };

    //监听搜索
    form.on('submit(query)', function(){
        reloadTable();
    });

    //监听重置查询
    form.on('submit(reset)', function(){
        resetAreaFn();
        $node.nameInput.val('');
        $node.residentialNumberInput.val('');
        $node.estatePid.val('');
        estateSelect.setValue([]);
        $node.provinceInput.val('');
        $node.cityInput.val('');
        $node.areaInput.val('');
        $node.regionInput.val('');
        reloadTable();
    });

    //监听批量删除
    form.on('submit(batchdel)', function(){
        if(ids.length == 0 ){
            layer.msg("请选择要删除的数据。");
            return;
        }
        layer.confirm('是否确认删除？',{icon: 7, title:'提示'}, function(index){
            $.ajax({
                url :   '/estate/residential/deleteResidentialList',
                type : 'POST',
                contentType: "application/json;charset=utf-8",
                data :JSON.stringify(ids),
                success :  function(result){
                    if(result.code == '200'){
                        if(result.data){
                            //  刷新表格
                            layuiTable.reload();
                            clearCheckbox();
                            layer.msg("删除成功");
                            layer.close(index);
                        }else{
                            layer.msg("删除失败");
                        }
                    }else{
                        layer.msg(result.msg);
                    }
                }
            });
        });
    });

    var estateSelect = xmSelect.render({
        el: '#estate_name',
        radio: true,
        prop: {
            name: 'name',
            value: 'id',
        },
        toolbar: {
            show: true,
            list: [{
                name: '清空',
                method: function(){
                    estateSelect.setValue([]);
                    $node.estatePid.val('');
                }
            }]
        },
        clickClose: true,
        filterable: true,
        remoteSearch: true,
        remoteMethod: function (val, cb, show) {
            $.ajax({
                type: 'GET',
                url: '/permissions/org/getListByLikeName',
                data: {
                    name : val,
                    flag    :   1,
                    orgType : 3,
                    selectTreeId : selectTreeId,
                    isSelect : true
                },
                success: function (result) {
                    cb(result.list);
                },
                error: function () {
                    cb([]);
                }
            });
        },
        //监听选择
        on: function (data) {
            var change = data.change;
            if (change.length > 0) {
                $node.estatePid.val(change[0].id)
            }
            if (!data.isAdd) {
                $node.estatePid.val('');
            }
        },
        //显示方式
        model: {
            label: {
                type: 'text',
                text: {
                    //左边拼接的字符
                    left: '',
                    //右边拼接的字符
                    right: '',
                    //中间的分隔符
                    separator: ', ',
                },
            }
        },
    });

    function initEstateFn() {
        var estateList;
        common.sendSyncRequest("/permissions/org/getListByLikeName", 'get', {flag : 1, orgType : 3, isSelect : true}, function (result) {
            estateList = result.list;
        });
        return estateList;
    }

});